#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Blue

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

extern int Lag            = 100;
extern int NumComps       = 4;
extern int NumberOfBars   = 300;
extern int ATRPeriod1     = 20;
extern int ATRPeriod2     = 20;
extern int ATRmultiplier1 = 2;
extern int ATRmultiplier2 = 2;

double SSA[];
double SSAu[];
double SSAd[];
double sourceValues1[];
double sourceValues2[];
double sourceValues3[];
double calcValues[];

int init() {
   IndicatorBuffers(3);
   SetIndexBuffer(0, SSA);
   SetIndexBuffer(1, SSAu);
   SetIndexBuffer(2, SSAd);
   return (0);
}

int deinit() {
   return (0);
}

int start() 
{
   int n = MathMax(NumberOfBars,Bars),counted_bars=IndicatorCounted();
      if (ArraySize(sourceValues1) != n) { ArrayResize(sourceValues1,n); ArrayResize(sourceValues2,n); ArrayResize(sourceValues3,n); ArrayResize(calcValues,n); }
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,n-1);
                   SetIndexDrawBegin(0,Bars-n);
                   SetIndexDrawBegin(1,Bars-n);
                   SetIndexDrawBegin(2,Bars-n);
           limit=n-1;

   for (int i = limit; i >= 0; i--) 
   {
      sourceValues1[i] = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i);
      sourceValues2[i] = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i) + ATRmultiplier1*iATR(NULL,0,ATRPeriod1,i);
      sourceValues3[i] = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i) - ATRmultiplier1*iATR(NULL,0,ATRPeriod1,i);;
   }
   fastSingular(sourceValues1,n,Lag,NumComps,calcValues); ArrayCopy(SSA ,calcValues);
   fastSingular(sourceValues2,n,Lag,NumComps,calcValues); ArrayCopy(SSAu,calcValues);
   fastSingular(sourceValues3,n,Lag,NumComps,calcValues); ArrayCopy(SSAd,calcValues);
   return (0);
}